/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import baza.RadSaBazom;
import domen.Korisnik;
import domen.Mesto;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.sql.SQLException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import transfer.TOKlijentZahtev;
import transfer.TOServerOdgovor;
import util.Util;

/**
 *
 * @author student1
 */
public class Server {

    public static void main(String[] args) {
        Server server = new Server();
        try {
            server.pokreniServerProgram();
        } catch (Exception ex) {
            Logger.getLogger(Server.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void pokreniServerProgram() throws IOException, ClassNotFoundException {
        ServerSocket ssoket = new ServerSocket(9000);
        Socket soket = ssoket.accept();
        pokreniKomunikaciju(soket);
    }

    private void pokreniKomunikaciju(Socket soket) throws IOException, ClassNotFoundException {        
        while (true) {
            ObjectInputStream inSoket = new ObjectInputStream(soket.getInputStream());
            TOKlijentZahtev zahtev = (TOKlijentZahtev) inSoket.readObject();
            int operacija = zahtev.getOperacija();
            izvrsiOperaciju(operacija, soket,zahtev.getParametar());

        }
    }

    private void izvrsiOperaciju(int operacija, Socket soket, Object parametar) throws IOException {
        if (operacija == Util.OPERACIJA_VRATI_SVA_MESTA) {
            RadSaBazom broker = new RadSaBazom();
            List<Mesto> listaMesta = null;
            int statusIzvrsenjaOperacije=Util.STATUS_IZVRSENJA_OPERACIJE_OK;
            String poruka = "";
            try {
                listaMesta = broker.vratiSvaMesta();
            } catch (SQLException ex) {
                statusIzvrsenjaOperacije = Util.STATUS_IZVRSENJA_OPERACIJE_NOT_OK;
                poruka = ex.getMessage();
                ex.printStackTrace();
            }
            TOServerOdgovor odgovor = new TOServerOdgovor();
            odgovor.setRezultat(listaMesta);
            odgovor.setStatusIzvrsenjaOperacije(statusIzvrsenjaOperacije);
            odgovor.setPoruka(poruka);
            // posalji odgovor klijentu
            ObjectOutputStream out = new ObjectOutputStream(soket.getOutputStream());
            out.writeObject(odgovor);
            
        }
        
        if(operacija == Util.OPERACIJA_UBACI_KORISNIKA){
        RadSaBazom broker = new RadSaBazom();
        int statusIzvrsenjaOperacije=Util.STATUS_IZVRSENJA_OPERACIJE_OK;
            String poruka = "";
            try {
                
                broker.sacuvajKorisnika((Korisnik)parametar);
            } catch (Exception e) {
                statusIzvrsenjaOperacije = Util.STATUS_IZVRSENJA_OPERACIJE_NOT_OK;
                poruka = e.getMessage();
                e.printStackTrace();
            }
            TOServerOdgovor odgovor = new TOServerOdgovor();
            odgovor.setRezultat(null);
            odgovor.setStatusIzvrsenjaOperacije(statusIzvrsenjaOperacije);
            odgovor.setPoruka(poruka);
            // posalji odgovor klijentu
            ObjectOutputStream out = new ObjectOutputStream(soket.getOutputStream());
            out.writeObject(odgovor);
        }
    }

}
