/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.components.table.model;

import domen.Korisnik;
import java.util.ArrayList;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class MojModelTabeleKorisnik extends AbstractTableModel {
    
    List<Korisnik> listaKorisnika;
    
    public MojModelTabeleKorisnik() {
        listaKorisnika = new ArrayList<>();
    }
    
    @Override
    public int getRowCount() {
        return listaKorisnika.size();
    }
    
    @Override
    public int getColumnCount() {
        return 4;
    }
    
    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        
        Korisnik k = listaKorisnika.get(rowIndex);
        
        switch (columnIndex) {
            case 0:
                return k.getKorisnickoIme();
            case 1:
                return k.getIme();
            case 2:
                return k.getPrezime();
            case 3:
                return k.getAdresa().getNazivUlice()
                        + " " + k.getAdresa().getMesto().getNaziv();
            default:
                return "Greska";
        }
        
    }
    
    @Override
    public String getColumnName(int column) {
        
        switch (column) {
            case 0:
                return "Korisnicko ime";
            case 1:
                return "Ime";
            case 2:
                return "Prezime";
            case 3:
                return "Adresa";
            default:
                return "Greska";
        }
    }
    
    public void dodajNovogKorisnika(Korisnik k) {
        
        listaKorisnika.add(k);
        fireTableDataChanged();
    }
    
    public void ukolniKorisnika(int row) throws Exception {
        if (row > -1) {
            listaKorisnika.remove(row);
            fireTableDataChanged();
        } else {
            throw new Exception("Nije selektovan red!");
        }
    }

    public List<Korisnik> vratiListuKorisnika() {
        return listaKorisnika;
    }
    
    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        
        if (columnIndex == 0) {
            return true;
        }
        
        return false;
    }
    
    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        Korisnik k = listaKorisnika.get(rowIndex);
        
        if (columnIndex == 0) {
            k.setKorisnickoIme(aValue.toString());
        }
    }
    
}
