/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.components.tabela.model;

import domen.Racun;
import domen.StavkaRacuna;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class ModelTabeleRacun extends AbstractTableModel {

    Racun racun;

    public ModelTabeleRacun(Racun racun) {
        this.racun = racun;
    }

    @Override
    public int getRowCount() {
        return racun.getStavkeRacuna().size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaRacuna sr = racun.getStavkeRacuna().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return sr.getRbStavke();
            case 1:
                return sr.getProizvod().getNaziv();
            case 2:
                return sr.getKolicina();
            case 3:
                return sr.getCena();
            case 4:
                return sr.getKolicina() * sr.getCena();
            default:
                return "Greska.";

        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "RB";
            case 1:
                return "Proizvod";
            case 2:
                return "Kolicina";
            case 3:
                return "Cena";
            case 4:
                return "Iznos na stavci";
            default:
                return "Greska.";

        }
    }

    public void dodajStavku(StavkaRacuna sr) {
        sr.setRacun(racun);
        sr.setRbStavke(racun.getStavkeRacuna().size() + 1);
        racun.getStavkeRacuna().add(sr);
        
        racun.setUkIznos(racun.getUkIznos()+sr.getKolicina()*sr.getCena());
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 2) {
            return true;
        }
        return false;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaRacuna sr=racun.getStavkeRacuna().get(rowIndex);
        if(columnIndex==2)
        sr.setKolicina(Double.parseDouble(aValue.toString()));
        fireTableDataChanged();
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        if(columnIndex==2)
            return Double.class;
        return Object.class; //To change body of generated methods, choose Tools | Templates.
    
    }

    public Racun vratiRacun() {
        return racun;
    }
    

}
