/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dbbr;

import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student1
 */
public class DBBroker {

    Connection konekcija;

    public void uspostaviKonekciju() throws Exception {
        //Ucitavamo drajver
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        // Uspostavljamo konekciju
        konekcija = DriverManager.getConnection("jdbc:odbc:BazaD4");
        konekcija.setAutoCommit(false);
    }

    public void zatvoriKonekciju() throws SQLException {
        if (konekcija != null) {
            konekcija.close();
        }
    }

    public void potvrdiTransakciju() throws SQLException {
        konekcija.commit();
    }

    public void ponistiTransakciju() throws SQLException {
        konekcija.rollback();
    }

    public List<Mesto> vratiSvaMesta() throws SQLException {

        List<Mesto> listaMesta = new ArrayList<Mesto>();

        String upit = "SELECT * FROM MESTO";

        Statement naredba = konekcija.createStatement();

        ResultSet rs = naredba.executeQuery(upit);

        while (rs.next()) {
            int ptt = rs.getInt("ptt");
            String naziv = rs.getString("naziv");
            Mesto m = new Mesto(ptt, naziv);
            listaMesta.add(m);
        }

        return listaMesta;
    }

    public void sacuvajMesto(Mesto mesto) throws SQLException {
        // INSERT INTO MESTO VALUES (11000,'Beograd')

        String upit = "INSERT INTO MESTO VALUES ("
                + mesto.getPtt() + ",'" + mesto.getNaziv() + "')";

        Statement naredba = konekcija.createStatement();
        naredba.executeUpdate(upit);

    }

    public void sacuvajMestoBoljiNacin(Mesto mesto) throws SQLException {
        // INSERT INTO MESTO VALUES (11000,'Beograd')

        String upit = "INSERT INTO MESTO VALUES (?,?)";

        PreparedStatement naredba = konekcija.prepareStatement(upit);
        // postavljaju se parametri u upit
        naredba.setInt(1, (int) mesto.getPtt());
        naredba.setString(2, mesto.getNaziv());
        naredba.executeUpdate();

    }

    public void sacuvajKorisnika(Korisnik k) throws SQLException {

        String upit = "INSERT INTO KORISNIK VALUES (?,?,?,?,?,?,?,?)";

        PreparedStatement naredba = konekcija.prepareStatement(upit);

        naredba.setString(1, k.getJmbg());
        naredba.setString(2, k.getIme());
        naredba.setString(3, k.getPrezime());
        naredba.setString(4, k.getKorisnickoIme());
        naredba.setString(5, k.getKorisnickaSifra());
        naredba.setString(6, k.getAdresa().getNazivUlice());
        naredba.setString(7, k.getAdresa().getBroj());
        naredba.setInt(8, (int) k.getAdresa().getMesto().getPtt());

        naredba.executeUpdate();

    }

    public List<Korisnik> vratiKorisnike() throws Exception {
        try {
            String sql = "SELECT * FROM Korisnik k INNER JOIN Mesto m ON (m.ptt=k.mesto)";
            Statement sqlNaredba = konekcija.createStatement();
            List<Korisnik> lk = new ArrayList<>();
            ResultSet rs = sqlNaredba.executeQuery(sql);
            while (rs.next()) {
                Korisnik k = new Korisnik();
                k.setJmbg(rs.getString("jmbg"));
                k.setIme(rs.getString("ime"));
                k.setPrezime(rs.getString("prezime"));
                k.setKorisnickoIme(rs.getString("korisnickoIme"));
                k.setKorisnickaSifra(rs.getString("korisnickaSifra"));
                k.getAdresa().setBroj(rs.getString("broj"));
                k.getAdresa().setNazivUlice(rs.getString("nazivUlice"));
                Mesto m = new Mesto();
                m.setNaziv(rs.getString("naziv"));
                m.setPtt(rs.getLong("ptt"));
                k.getAdresa().setMesto(m);
                
                lk.add(k);
            }
            return lk;
            
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Neuspesno ucitavanje korisnika!");
        }
    }

    public List<Proizvod> vratiProizvode() throws Exception {
        try {
            String sql = "SELECT * FROM Proizvod";
            Statement sqlNaredba = konekcija.createStatement();
            ResultSet rs = sqlNaredba.executeQuery(sql);
            List<Proizvod> lp = new ArrayList<>();
            while (rs.next()) {
                Proizvod p = new Proizvod();
                p.setProizvodID(rs.getInt("proizvodID"));
                p.setNaziv(rs.getString("naziv"));
                p.setCena(rs.getInt("cena"));
                lp.add(p);
            }
            return lp;
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Neuspesno ucitavanje proizvoda!");
        }
        
    }

    public void sacuvajRacun(Racun racun) throws Exception { 
        try {
            String sql = "INSERT INTO Racun VALUES (?,?,?,?)";
            PreparedStatement sqlNaredba = konekcija.prepareStatement(sql);
            sqlNaredba.setInt(1, racun.getBrojRacuna());
            sqlNaredba.setDate(2, new java.sql.Date(racun.getDatum().getTime()));
            sqlNaredba.setInt(3, racun.getUkupanIznos());
            sqlNaredba.setString(4, racun.getKorisnik().getJmbg());
            sqlNaredba.executeUpdate();
            
            sql = "INSERT INTO StavkaRacuna VALUES (?,?,?,?,?,?)";
            sqlNaredba = konekcija.prepareStatement(sql);
            for (StavkaRacuna s : racun.getListaStavki()) {
                sqlNaredba.setInt(1, racun.getBrojRacuna());
                sqlNaredba.setInt(2, s.getRb());
                sqlNaredba.setInt(3, s.getProizvod().getProizvodID());
                sqlNaredba.setInt(4, s.getKolicina());
                sqlNaredba.setInt(5, s.getProizvod().getCena());
                sqlNaredba.setInt(6, s.getIznos());
                sqlNaredba.executeUpdate();
            }
            sqlNaredba.close();
            
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Neuspesno cuvanje racuna!");
        }
    }

}
