/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import dbbr.DBBroker;
import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import domen.Racun;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import kolekcije.KolekcijaKorisnika;
import kolekcije.KolekcijaMesta;
import ui.gui.FrmGlavna;

/**
 *
 * @author student1
 */
public class Kontroler {

    private static Kontroler objekatKontroler;

    private HashMap mapaPodataka;

    DBBroker dbbr;

    private Kontroler() {
        kolekcijaKorisnika = new KolekcijaKorisnika();
        kolekcijaMesta = new KolekcijaMesta();
        mapaPodataka = new HashMap();
        dbbr = new DBBroker();
    }
    KolekcijaKorisnika kolekcijaKorisnika;
    KolekcijaMesta kolekcijaMesta;

    public static Kontroler vratiObjekatKontroler() {

        if (objekatKontroler == null) {
            objekatKontroler = new Kontroler();
        }

        return objekatKontroler;
    }

    public void dodajKorisnika(Korisnik k) {

        kolekcijaKorisnika.dodajKorisnika(k);
    }

    public List<Mesto> vratiSvaMesta() throws Exception {

        List<Mesto> listaMesta = null;
        try {
           dbbr.uspostaviKonekciju();
        } catch (Exception ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
            throw new Exception("GRESKA PRILIKOM Otvaranja konekcije!!!");
        }
        try {
            listaMesta = dbbr.vratiSvaMesta();
            dbbr.potvrdiTransakciju();
        } catch (SQLException sqle) {
            dbbr.ponistiTransakciju();
            throw new Exception("GRESKA prilikom izvrsavanja upita!!!");
        }
        try {
            dbbr.zatvoriKonekciju();
            return listaMesta;
        } catch (Exception ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
            throw new Exception("GRESKA PRILIKOM Zatvaranja konekcije!!!");
        }

    }

    public List<Korisnik> vratiSveKorisnike() throws Exception {
        dbbr.uspostaviKonekciju();
        List<Korisnik> lk = dbbr.vratiKorisnike();
        dbbr.potvrdiTransakciju();
        dbbr.zatvoriKonekciju();
        return lk;
    }

    public void ucitajPodatkeIzDatoteke() {
        ObjectInputStream ois = null;
        try {

            // KADA SE PRVI PUT UCITAVAJU PODACI DESICE SE IZUZETAK JER NE POSTOJI DATOTEKA
            FileInputStream fis = new FileInputStream("Korisnici.dat");
            ois = new ObjectInputStream(fis);
            List<Korisnik> listaKorisnika = (List<Korisnik>) ois.readObject();
            for (Korisnik korisnik : listaKorisnika) {
                kolekcijaKorisnika.dodajKorisnika(korisnik);
            }

        } catch (IOException ex) {
            //Logger.getLogger(FrmGlavna.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("Ne postoji datoteka");
        } catch (ClassNotFoundException ex) {
            //Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                if (ois != null) {
                    ois.close();
                }
            } catch (IOException ex) {
                // Logger.getLogger(FrmGlavna.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }

    public void sacuvajPodatkeUDatoteku() {

        try {
            // Kada se prvi put cuvaju podaci Datoteka ce biti kreirana
            FileOutputStream fos = new FileOutputStream("Korisnici.dat");
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            oos.writeObject(kolekcijaKorisnika.vratiSveKorisnike());

        } catch (IOException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public HashMap getMapaPodataka() {
        return mapaPodataka;
    }

    public void setMapaPodataka(HashMap mapaPodataka) {
        this.mapaPodataka = mapaPodataka;
    }

    public void sacuvajMesto(Mesto mesto) throws Exception {
        try {
            dbbr.uspostaviKonekciju();
            dbbr.sacuvajMestoBoljiNacin(mesto);
            dbbr.zatvoriKonekciju();
        } catch (Exception ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
            throw new Exception("Mesto nije uspesno sacuvano");
        }

    }

    public void sacuvajSveKorisnike(List<Korisnik> listaNovihKorisnika) throws Exception {
        try {
            dbbr.uspostaviKonekciju();

            for (int i = 0; i < listaNovihKorisnika.size(); i++) {
                Korisnik korisnik = listaNovihKorisnika.get(i);
                dbbr.sacuvajKorisnika(korisnik);
            }
            dbbr.potvrdiTransakciju();
            
        } catch (Exception ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
            dbbr.ponistiTransakciju();
        }
        dbbr.zatvoriKonekciju();

    }

    public List<Proizvod> vratiProizvode() throws Exception {
        dbbr.uspostaviKonekciju();
        List<Proizvod> lp = dbbr.vratiProizvode();
        dbbr.potvrdiTransakciju();
        dbbr.zatvoriKonekciju();
        return lp;
    }

    public void sacuvajRacun(Racun racun) throws Exception {
        try {
            dbbr.uspostaviKonekciju();
            dbbr.sacuvajRacun(racun);
            dbbr.potvrdiTransakciju();
            dbbr.zatvoriKonekciju();
        } catch (Exception ex) {
            dbbr.ponistiTransakciju();
            dbbr.zatvoriKonekciju();
            throw ex;
        }
    }

}
