/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package dbbr;

import domen.Korisnik;
import domen.Mesto;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student1
 */
public class DBBroker {
    
    Connection konekcija;
    
    
    public void uspostaviKonekciju() throws Exception{
        // Ucitavanje drajvera
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        // Uspostavljanje konekcije sa bazom
        konekcija = DriverManager.getConnection("jdbc:odbc:BazaD1");
        konekcija.setAutoCommit(false);
    }
    
    
    public List<Mesto> vratiSvaMesta() throws Exception{
        
        List<Mesto> listaMesta = new ArrayList<>();
        
        String upit = "SELECT ptt,naziv FROM MESTO";
        Statement naredba  = konekcija.createStatement();
        
        ResultSet rs = naredba.executeQuery(upit);
        
        while(rs.next()){            
            long ptt =(long) rs.getInt("ptt");
            String naziv = rs.getString("naziv");
            Mesto m = new Mesto(ptt, naziv);
            listaMesta.add(m);           
        }
        
        return listaMesta;
    }
    
    public void sacuvajMesto(Mesto m) throws SQLException{
        
//        String upit = "INSERT INTO "
//                + "MESTO values ("+m.getPtt()+",'"+m.getNaziv()+"')";
//        System.out.println("upit:"+upit);
//        Statement naredba = konekcija.createStatement();
//        naredba.executeUpdate(upit);       
        
        String upit =  "INSERT INTO MESTO VALUES (?,?)";
        PreparedStatement ps = konekcija.prepareStatement(upit);
        
        ps.setInt(1, (int)m.getPtt());
        ps.setString(2, m.getNaziv());      
        
        ps.executeUpdate();
        
    }
    

    public void sacuvajKorisnika(Korisnik k) throws SQLException{
        
        String upit = "INSERT INTO KORISNIK VALUES (?,?,?,?,?,?,?,?)";
        PreparedStatement ps = konekcija.prepareStatement(upit);
        
        ps.setString(1, k.getJmbg());
        ps.setString(2, k.getIme());
        ps.setString(3, k.getPrezime());
        ps.setString(4, k.getKorisnickoIme());
        ps.setString(5, k.getKorisnickaSifra());
        ps.setString(6, k.getAdresa().getNazivUlice());
        ps.setString(7, k.getAdresa().getBroj());
        ps.setInt(8, (int)k.getAdresa().getMesto().getPtt());
        
        ps.executeUpdate();
        
    }
    
    public void zatvoriKonekciju() throws SQLException {

        konekcija.close();
    }
    
    public void potvrdiTransakciju() throws SQLException{
        
        konekcija.commit();
    }
    
    public void ponistiTransakciju() throws SQLException{ 
        if (konekcija!=null){
            konekcija.rollback();
        }
    }
    
}
