/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package dbbr;

import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student1
 */
public class DBBroker {
    
    Connection konekcija;
    
    public void uspostaviKonekciju() throws Exception{
        // UCITAVA SE DRAJVER
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        // USPOSTAVLJAMO KONEKCIJU
        konekcija = DriverManager.getConnection("jdbc:odbc:BazaD2");
        konekcija.setAutoCommit(false);
    }
    

    public void potvrdiTransakciju() throws SQLException{
        konekcija.commit();
    }
    
    public void ponistiTransakciju() throws SQLException{
        konekcija.rollback();
    }
    
    
    public List<Mesto> vratiSvaMesta() throws Exception{
        
        List<Mesto> listaMesta = new ArrayList<>();
        
        String upit = "SELECT ptt, naziv FROM MESTO";
        Statement naredba = konekcija.createStatement();
        ResultSet rs = naredba.executeQuery(upit);
        while(rs.next()){            
            long ptt = rs.getLong("ptt");
            String naziv = rs.getString("naziv");
            Mesto m = new Mesto(ptt, naziv);
            listaMesta.add(m);
        }
        return listaMesta;
    }

    public void zatvoriKonekciju() throws Exception{
        
        konekcija.close();
        
    }
    
    public void sacuvajMesto(Mesto m) throws SQLException{
        
        String upit = "INSERT INTO "
                + "MESTO VALUES("+m.getPtt()+",'"+m.getNaziv()+"')";        
        System.out.println("upit:"+upit);
        Statement naredba = konekcija.createStatement();
        naredba.executeUpdate(upit);
       
    }
    
    public void sacuvajKorisnika(Korisnik k) throws SQLException{
        
        String upit = "INSERT INTO KORISNIK VALUES (?,?,?,?,?,?,?,?)";
        
        PreparedStatement ps = konekcija.prepareStatement(upit);
        
        ps.setString(1, k.getJmbg());
        ps.setString(2, k.getIme());
        ps.setString(3, k.getPrezime());
        ps.setString(4, k.getKorisnickoIme());
        ps.setString(5, k.getKorisnickaSifra());
        ps.setString(6, k.getAdresa().getNazivUlice());
        ps.setString(7, k.getAdresa().getBroj());
        ps.setInt(8, (int)k.getAdresa().getMesto().getPtt());
        
        ps.executeUpdate();
    }
    
    public List<Korisnik> vratiSveKorisnike() throws SQLException{
        
        List<Korisnik> listaKorisnika = new ArrayList<>();        
        String upit = " SELECT Korisnik.*, Mesto.* " +
                      " FROM Mesto INNER JOIN Korisnik ON Mesto.ptt = Korisnik.mesto;";        
        Statement naredba = konekcija.createStatement();        
        ResultSet rs = naredba.executeQuery(upit);        
        while(rs.next()){            
            Korisnik k = new Korisnik();            
            k.setJmbg(rs.getString("jmbg"));
            k.setIme(rs.getString("ime"));
            k.setPrezime(rs.getString("prezime"));            
            k.setKorisnickaSifra(rs.getString("korisnickaSifra"));
            k.setKorisnickoIme(rs.getString("korisnickoIme"));
            k.getAdresa().setNazivUlice(rs.getString("nazivUlice"));
            k.getAdresa().setBroj(rs.getString("broj"));            
            Mesto m = new Mesto();
            m.setPtt(rs.getInt("ptt"));
            m.setNaziv(rs.getString("naziv"));
            k.getAdresa().setMesto(m);            
            listaKorisnika.add(k);           
        }
        return listaKorisnika;
    }
    
    public List<Proizvod> vratiSveProizvode() throws SQLException{
        
        List<Proizvod> listaProizvoda = new ArrayList<>();
        
        String upit = "Select * from proizvod";        
        Statement naredba = konekcija.createStatement();
        ResultSet rs = naredba.executeQuery(upit);
        while(rs.next()){
            Proizvod p  = new Proizvod();
            p.setProizvodID(rs.getInt("proizvodID"));
            p.setNaziv(rs.getString("naziv"));
            p.setCena(rs.getDouble("cena"));
            
            listaProizvoda.add(p);
        }
        
        return listaProizvoda;
        
    }
    
}
