/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import dbbr.DBBroker;
import domen.Korisnik;
import domen.Mesto;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import kolekcije.KolekcijaKorisnika;
import kolekcije.KolekcijaMesta;
import ui.gui.FrmGlavna;

/**
 *
 * @author student1
 */
public class Kontroler {

    private static Kontroler objekatKontroler;

    HashMap mapaPodataka;

    DBBroker dbbr;

    private Kontroler() {
        kolekcijaKorisnika = new KolekcijaKorisnika();
        kolekcijaMesta = new KolekcijaMesta();
        mapaPodataka = new HashMap();
        dbbr = new DBBroker();
    }
    KolekcijaKorisnika kolekcijaKorisnika;
    KolekcijaMesta kolekcijaMesta;

    public static Kontroler vratiObjekatKontroler() {

        if (objekatKontroler == null) {
            objekatKontroler = new Kontroler();
        }

        return objekatKontroler;
    }

    public void dodajKorisnika(Korisnik k) {

        kolekcijaKorisnika.dodajKorisnika(k);
    }

    public List<Mesto> vratiSvaMesta() throws Exception {
        //return kolekcijaMesta.getListaMesta();
        dbbr.uspostaviKonekciju();
        List<Mesto> listaMesta = dbbr.vratiSvaMesta();
        dbbr.zatvoriKonekciju();
        return listaMesta;
    }

    public void sacuvajMesto(Mesto m) throws Exception {
        dbbr.uspostaviKonekciju();
        dbbr.sacuvajMesto(m);
        dbbr.zatvoriKonekciju();

    }

    public List<Korisnik> vratiSveKorisnike() {
        return kolekcijaKorisnika.vratiSveKorisnike();
    }

    public void dodajUMapu(String kljuc, Object vrednost) {
        mapaPodataka.put(kljuc, vrednost);
    }

    public Object vratiIzMape(String kljuc) {

        return mapaPodataka.get(kljuc);
    }

    public void ukloniIzMape(String kljuc) {
        mapaPodataka.remove(kljuc);
    }

    public void ucitajPodatkeIzDatoteke() {
        ObjectInputStream ois = null;
        try {

            // KADA SE PRVI PUT UCITAVAJU PODACI DESICE SE IZUZETAK JER NE POSTOJI DATOTEKA
            FileInputStream fis = new FileInputStream("Korisnici.dat");
            ois = new ObjectInputStream(fis);
            List<Korisnik> listaKorisnika = (List<Korisnik>) ois.readObject();
            for (Korisnik korisnik : listaKorisnika) {
                kolekcijaKorisnika.dodajKorisnika(korisnik);
            }

        } catch (IOException ex) {
            //Logger.getLogger(FrmGlavna.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("Ne postoji datoteka");
        } catch (ClassNotFoundException ex) {
            //Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                if (ois != null) {
                    ois.close();
                }
            } catch (IOException ex) {
                // Logger.getLogger(FrmGlavna.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }

    public void sacuvajPodatkeUDatoteku() {

        try {
            // Kada se prvi put cuvaju podaci Datoteka ce biti kreirana
            FileOutputStream fos = new FileOutputStream("Korisnici.dat");
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            oos.writeObject(kolekcijaKorisnika.vratiSveKorisnike());

        } catch (IOException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
