/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package ui.gui.racun.modeltabele;

import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import java.util.List;
import javax.swing.JTextField;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class ModelTabeleRacun extends AbstractTableModel {
    private Racun racun;
    private String[] kolone = new String[]{"RB", "Proizvod", "Cena", "Kolicina", "Iznos"};
//    JTextField jtfUkupanIznos;
    
//    public ModelTabeleRacun(Racun racun,JTextField jtfUkupanIznos) {
//        this.racun = racun;
//        this.jtfUkupanIznos = jtfUkupanIznos;
//    }

    public ModelTabeleRacun(Racun racun) {
        this.racun = racun;        
    }
    
    @Override
    public int getRowCount() {
        if (racun == null || racun.getListaStavki() == null) {
            return 0;
        }
        return racun.getListaStavki().size();
    }

    @Override
    public int getColumnCount() {
        return kolone.length;
    }

    @Override
    public String getColumnName(int column) {
        return kolone[column];
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaRacuna stavka = racun.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0: return stavka.getRb();
            case 1: return stavka.getProizvod();
            case 2: return stavka.getProizvod().getCena();
            case 3: return stavka.getKolicina();
            case 4: return stavka.getIznos();
            default: return "Greska";
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 1 || columnIndex == 3) {
            return true;
        }
        return false;
    }
    
    public void dodajStavku() {
        int rb = racun.getListaStavki().size() + 1; //nije dobro resenje
        StavkaRacuna stavka = new StavkaRacuna();
        stavka.setRb(rb);
        stavka.setRacun(racun);
        racun.getListaStavki().add(stavka);        
        fireTableDataChanged();
    }
    
    public Racun getRacun() {
        return racun;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaRacuna stavka = racun.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0: //nema promene
                    break;
            case 1: stavka.setProizvod((Proizvod)aValue);
                    stavka.setCena(stavka.getProizvod().getCena());
                    stavka.setIznos(stavka.getCena() * stavka.getKolicina());
//                    racun.izracunajUkupanIznos();
//                    jtfUkupanIznos.setText(String.valueOf(racun.getUkupanIznos()));
                    fireTableRowsUpdated(rowIndex, rowIndex);
                    break;
            case 2: //nema promene
                    break;
            case 3: stavka.setKolicina(Integer.parseInt((String)aValue));
                    stavka.setIznos(stavka.getCena() * stavka.getKolicina());
//                    racun.izracunajUkupanIznos();
//                    jtfUkupanIznos.setText(String.valueOf(racun.getUkupanIznos()));
                    fireTableRowsUpdated(rowIndex, rowIndex);
                    break;
            case 4: //nema promene
                    break;
                
        }
    }
}
