/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ui.gui.racun.modeltabele;

import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class ModelTabeleRacun extends AbstractTableModel {

    Racun racun;

    public ModelTabeleRacun(Racun racun) {
        this.racun = racun;
    }

    String[] naziviKolona = new String[]{"rb", "prozivod", "kolicina", "cena", "iznos"};
    Class[] tipoviKolona = new Class[]{Integer.class, Proizvod.class, Double.class, Double.class, Double.class};

    @Override
    public int getRowCount() {
        return racun.getStavkeRacuna().size();
    }

    @Override
    public int getColumnCount() {
        return naziviKolona.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {

        StavkaRacuna stavka = racun.getStavkeRacuna().get(rowIndex);

        switch (columnIndex) {

            case 0:
                return stavka.getRb();

            case 1:
                return stavka.getProizvod();

            case 2:
                return stavka.getKolicina();

            case 3:
                return stavka.getCena();

            case 4:
                return stavka.getIznos();

            default:
                return null;

        }
        
        
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaRacuna stavka = racun.getStavkeRacuna().get(rowIndex);

        switch (columnIndex) {

            case 0:
                stavka.setRb((int)aValue);
                break;
            case 1:
                stavka.setProizvod((Proizvod)aValue);
                stavka.setCena(stavka.getProizvod().getCena());
                stavka.izracunajUkupno();
                fireTableRowsUpdated(rowIndex, rowIndex);
                break;
            case 2:
                stavka.setKolicina((double) aValue);
                stavka.izracunajUkupno();
                fireTableRowsUpdated(rowIndex, rowIndex);
                break;
            case 3:
                stavka.setCena((double) aValue);
                break;
            case 4:
                stavka.setIznos((double) aValue);
                break;
        }
    }
    
    
   public void dodajStavku(StavkaRacuna stavka) {
       stavka.setRacun(racun);
       stavka.setRb(racun.getStavkeRacuna().size()+1);
       racun.getStavkeRacuna().add(stavka);
       fireTableDataChanged();
   }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }

    @Override
    public String getColumnName(int column) {
        return naziviKolona[column];
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return tipoviKolona[columnIndex];
    }
   
    

    public Racun vratiRacun(){
        return racun;
    }
   

}
