package gui.components.table.model;

import domen.Korisnik;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class KorisnikTableModel extends AbstractTableModel{

    List<Korisnik> listaKorisnika;

    public KorisnikTableModel(List<Korisnik> listaKorisnika) {
        this.listaKorisnika = listaKorisnika;
    }
    
    @Override
    public int getRowCount() {
        return listaKorisnika.size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Korisnik korisnik = listaKorisnika.get(rowIndex);
        switch (columnIndex){
            case 0: return korisnik.getJMBG();
            case 1: return korisnik.getIme();
            case 2: return korisnik.getPrezime();
            case 3: return korisnik.getAdresa().getNazivUlice() + " " +
                    korisnik.getAdresa().getBroj();
            case 4: return korisnik.getAdresa().getMesto();
            default: return "Greska";
        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column){
            case 0: return "JMBG";
            case 1: return "Ime";
            case 2: return "Prezime";
            case 3: return "Adresa";
            case 4: return "Mesto";
            default: return "Greska";
        }
    }

    public void dodajRed(Korisnik korisnik) {
        listaKorisnika.add(korisnik);
        fireTableDataChanged();
    }

    public List<Korisnik> vratiPodatke() {
        return listaKorisnika;
    }
    
}
