package poslovnalogika;

//import baza.RadSaBazom;
import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import domen.Racun;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import transfer.TOKlijentZahtev;
import transfer.TOServerOdgovor;
import util.Util;

/**
 *
 * @author student1
 */
public class Kontroler {

    private KolekcijaKorisnika kolekcijaKorisnika;
    private static Kontroler objekatKontroler;
    private HashMap<String, Object> mapa;
    /**
     * Soket preko koga komuniciramo
     */
    private Socket soket;

    private Kontroler() {
        kolekcijaKorisnika = new KolekcijaKorisnika();
        mapa = new HashMap<>();
    }

    public static Kontroler vratiObjekatKontrolera() {
        if (objekatKontroler == null) {
            objekatKontroler = new Kontroler();
        }
        return objekatKontroler;
    }

    public KolekcijaKorisnika vratiKolekcijuKorisnika() {
        return kolekcijaKorisnika;
    }

    public void ubaciKorisnika(Korisnik korisnik) throws Exception {
        //kolekcijaKorisnika.ubaciNovogKorisnika(korisnik);
        //cuvanje podataka u bazi
        //RadSaBazom rsb = new RadSaBazom();
        //rsb.sacuvajKorisnika(korisnik);
        TOKlijentZahtev klijentZahtev = new TOKlijentZahtev();
        klijentZahtev.setOperacija(Util.OPERACIJA_SACUVAJ_KORISNIKA);
        klijentZahtev.setParametar(korisnik);
        ObjectOutputStream outSoket
                = new ObjectOutputStream(soket.getOutputStream());
        // belezimo zahtev u soket
        outSoket.writeObject(klijentZahtev);
        //sacekaj odgovor od servera
        ObjectInputStream inStream
                = new ObjectInputStream(soket.getInputStream());
        //dobijamo odgovor od servera
        TOServerOdgovor serverOdgovor
                = (TOServerOdgovor) inStream.readObject();
        int statusOperacije = serverOdgovor.getStatusIzvrsenja();
        if (statusOperacije == Util.STATUS_ODGOVOR_SERVER_NOT_OK) {
            throw new Exception(serverOdgovor.getPoruka());
        }
        
    }

    public HashMap<String, Object> getMapa() {
        return mapa;
    }

    public List<Mesto> vratiSvaMesta() throws SQLException, IOException, ClassNotFoundException, Exception {
        //return new RadSaBazom().vratiSvaMesta();
        TOKlijentZahtev klijentZahtev = new TOKlijentZahtev();
        klijentZahtev.setOperacija(Util.OPERACIJA_VRATI_SVA_MESTA);
        ObjectOutputStream outSoket
                = new ObjectOutputStream(soket.getOutputStream());
        // belezimo zahtev u soket
        outSoket.writeObject(klijentZahtev);
        //sacekaj odgovor od servera
        ObjectInputStream inStream
                = new ObjectInputStream(soket.getInputStream());
        //dobijamo odgovor od servera
        TOServerOdgovor serverOdgovor
                = (TOServerOdgovor) inStream.readObject();
        int statusOperacije = serverOdgovor.getStatusIzvrsenja();
        if (statusOperacije == 0) {
            return (List<Mesto>) serverOdgovor.getRezultat();
        } else {
            throw new Exception(serverOdgovor.getPoruka());
        }
    }

    public List<Korisnik> vratiSveKorisnike() throws Exception {
        //return new RadSaBazom().vratiSveKorisnike();
        return new ArrayList<>();
    }

    public void sacuvajKorisnike(List<Korisnik> listaKorisnika) {
//        RadSaBazom rsb = new RadSaBazom();
//
//        for (Korisnik korisnik : listaKorisnika) {
//            try {
//                rsb.sacuvajKorisnika(korisnik);
//            } catch (Exception ex) {
//                System.out.println("Korisnik sa sifrom " + korisnik.getKorisnickaSifra() + " postoji");
//            }
//        }

    }

    public void sacuvajKorisnikeCommit(List<Korisnik> listaKorisnika) throws SQLException {
        //RadSaBazom rsb = new RadSaBazom();
        //rsb.sacuvajKorisnike(listaKorisnika);
    }

    public List<Proizvod> vratiSveProizvode() throws Exception {
        //RadSaBazom rsb = new RadSaBazom();
        //return rsb.vratiSveProizvode();
        return new ArrayList<>();
    }

    public void sacuvajRacun(Racun racun) throws Exception {
//        RadSaBazom rsb = new RadSaBazom();
//        try {
//            rsb.sacuvajRacun(racun);
//        } catch (Exception ex) {
//            throw ex;
//        }
    }

    public Socket getSoket() {
        return soket;
    }

    public void setSoket(Socket soket) {
        this.soket = soket;
    }

}
