/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package forme.tabela.model;

import domen.Korisnik;
import java.util.List;
import javax.swing.table.AbstractTableModel;
import poslovnalogika.Kontroler;

/**
 *
 * @author student1
 */
public class KorisnikTableModel extends AbstractTableModel {
    private List<Korisnik> listaKorisnika;

    public KorisnikTableModel(List<Korisnik> lista) {
        listaKorisnika = lista;
    }
    
    @Override
    public int getRowCount() {
        if (listaKorisnika == null) {
            return 0;
        }
        return listaKorisnika.size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Korisnik k = listaKorisnika.get(rowIndex);
        switch (columnIndex) {
            case 0: return k.getJMBG();
            case 1: return k.getIme();
            case 2: return k.getPrezime();
            case 3: return k.getAdresa().getNazivUlice() + " " + k.getAdresa().getBroj();
            case 4: return k.getAdresa().getMesto();
            default: return "Greska";
        }
    }

    @Override
    public String getColumnName(int column) {
        return kolone[column];
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }
    
    public Korisnik vratiKorisnika(int red) {
        return listaKorisnika.get(red);
    }
    
    
    
    String[] kolone = new String[] {"JMBG", "Ime", "Prezime", "Adresa", "Mesto"};
    
}
