/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package baza;

import domen.Mesto;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class DbKomunikacija {
    private Connection connection;
    
    public void ucitajDriver() throws RuntimeException {
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//            driver je klasa
        } catch (Exception e) {
            throw new RuntimeException("Neuspesno ucitavanje drivera!");
        }
    }
    
    public void otvoriKonekciju() throws RuntimeException {
        try {
            connection = DriverManager.getConnection("jdbc:odbc:d2", "", "");
//            jdbc:protokol:naziv_baze
        } catch (Exception e) {
            throw new RuntimeException("Neuspesno otvaranje konekcije!");
        }
    }
    
    public void zatvoriKonekciju() throws RuntimeException {
        try {
            connection.close();
        } catch (Exception e) {
            throw new RuntimeException("Neuspesno zatvaranje konekcije!");
        }
    }
    
//    public void sacuvajMesto(Mesto m) throws RuntimeException{
//        try {
//            String upit = "INSERT INTO Mesto(ptt, naziv) VALUES (" + m.getPtt() + ",'" + m.getNaziv() + "')";
//            System.out.println(upit);
//            Statement st = connection.createStatement();
//            st.executeUpdate(upit);
////            za insert, update, delete -> executeUpdate
////            za select -> executeQuery
//            
//        } catch (SQLException ex) {
//            throw new RuntimeException("Neuspesno cuvanje mesta!");
//        }
//        
//    }
    public void sacuvajMesto(Mesto m) throws RuntimeException{
        try {
            String upit = "INSERT INTO Mesto values (?,?)";
            PreparedStatement ps = connection.prepareStatement(upit);
            //ps.setLong(1, m.getPtt());
            ps.setBigDecimal(1, new BigDecimal(m.getPtt()));
            ps.setString(2, m.getNaziv());
            ps.executeUpdate();
//            ukoliko se koristi PreparedStatement ide se bez parametra na executeUpdate
            
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new RuntimeException("Nemoguce cuvanje mesta u bazi!");
        }
    }
    
    public List<Mesto> vratiMesta() throws RuntimeException {
        List<Mesto> lm = new ArrayList<>();
        try {
            String upit = "SELECT * FROM Mesto";
            Statement st = connection.createStatement();
            ResultSet rs = st.executeQuery(upit);
            while(rs.next()) {
                String naziv = rs.getString("naziv");
                long ptt = rs.getLong(1);
                Mesto m = new Mesto(ptt, naziv);
                lm.add(m);
            }
        } catch (SQLException ex) {
            throw new RuntimeException("Nemoguce vratiti mesta!");
        }
        
        return lm;
    }
} 
