/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package forme.tabela.model;

import domen.Korisnik;
import domen.Mesto;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class KorisnikTableModel extends AbstractTableModel {
    private List<Korisnik> listaKorisnika;
    private boolean promena;

    public KorisnikTableModel(List<Korisnik> listaKorisnika) {
        this.listaKorisnika = listaKorisnika;
        this.promena = false;
    }

    public KorisnikTableModel(List<Korisnik> listaKorisnika, boolean promena) {
        this.listaKorisnika = listaKorisnika;
        this.promena = promena;
    }
    
    @Override
    public int getRowCount() {
        if (listaKorisnika == null) {
            return 0;
        }
        return listaKorisnika.size();
    }

    @Override
    public int getColumnCount() {
        return 6;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Korisnik k = listaKorisnika.get(rowIndex);
        switch (columnIndex) {
            case 0: return k.getJmbg();
            case 1: return k.getIme();
            case 2: return k.getPrezime();
            case 3: return k.getAdresa().getNazivUlice();
            case 4: return k.getAdresa().getBroj();
            case 5: return k.getAdresa().getMesto();
            default: return "Greska";
        }
    }

    @Override
    public String getColumnName(int column) {
        return kolone[column];
    }
    
    String[] kolone = new String[]{"JMBG","Ime","Prezime","Ulica","Broj","Mesto"};

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return promena;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        Korisnik k = listaKorisnika.get(rowIndex);
        switch (columnIndex) {
            case 0: k.setJmbg((String)aValue); break;
            case 1: k.setIme((String)aValue); break;
            case 2: k.setPrezime((String)aValue); break;
            case 3: k.getAdresa().setNazivUlice((String)aValue); break;
            case 4: k.getAdresa().setBroj((String)aValue); break;
            case 5: k.getAdresa().setMesto((Mesto)aValue); break;
        }
    }
    
    
    
    public Korisnik vratiKorisnika(int red) {
        return listaKorisnika.get(red);
    }
    
    public void dodajRed(Korisnik k) {
        listaKorisnika.add(k);
        System.out.println("Dodat novi korisnik!");
        fireTableDataChanged();
    }
    
    public void obrisiRed(int rb) {
        listaKorisnika.remove(rb);
        fireTableDataChanged();
    }
    
    public List<Korisnik> getListaKorisnika() {
        return listaKorisnika;
    }
    
}
