/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package poslovnalogika;

import baza.DbKomunikacija;
import domen.Korisnik;
import domen.Mesto;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @author student1
 */
public class Kontroler {
    private KolekcijaKorisnika kk;
    private KolekcijaMesta km;
    private static Kontroler kontroler;
    private Map<String, Object> mapa;
    private DbKomunikacija db;

    private Kontroler() {
        km = new KolekcijaMesta();
        kk = new KolekcijaKorisnika();
        mapa = new HashMap<String, Object>();
        db = new DbKomunikacija();
    }
    
    public static Kontroler vratiObjekat() {
        if (kontroler == null) {
            kontroler = new Kontroler();
        }
        return kontroler;
    }
    
    public void dodajKorisnika(Korisnik k) {
        kk.dodajKorisnika(k);
    }
    
    public List<Korisnik> vratiKorisnike() {
        return kk.vratiKorisnike();
    }
    
    public void dodajMesto(Mesto m) throws RuntimeException {
//        km.dodajMesto(m);
        db.ucitajDriver();
        db.otvoriKonekciju();
        db.sacuvajMesto(m);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }
    
    public List<Mesto> vratiMesta() {
//        return km.vratiMesta();
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Mesto> lm = db.vratiMesta();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lm;
    }

    public Map<String, Object> getMapa() {
        return mapa;
    }
    
    public void sacuvajKorisnike(List<Korisnik> lk) throws RuntimeException {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            for (Korisnik k : lk) {
                db.sacuvajKorisnika(k);
                System.out.println("Sacuvan korisnik: " + k.getJmbg());
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }
    
    
    
    
    
}
