/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package forme.tabela.model;

import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class RacunTableModel extends AbstractTableModel {
    private Racun racun;

    public RacunTableModel(Racun racun) {
        this.racun = racun;
    }
    
    public Racun vratiRacun() {
        return racun;
    }

    @Override
    public int getRowCount() {
        if (racun == null || racun.getListaStavki() == null) {
            return 0;
        }
        return racun.getListaStavki().size();
    }

    @Override
    public int getColumnCount() {
        return 4;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaRacuna stavka = racun.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0: return stavka.getRbStavke();
            case 1: return stavka.getProizvod();
            case 2: return stavka.getKolicina();
            case 3: return stavka.getIznos();
            default: return "Greska";
        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0: return "RB";
            case 1: return "Proizvod";
            case 2: return "Količina";
            case 3: return "Iznos";
            default: return "Greska";
        }
    }
    
    public void dodajStavku() {
        int rb = racun.getListaStavki().size() + 1; //nije dobro resenje
        racun.getListaStavki().add(new StavkaRacuna(racun.getRacunID(), rb, 0, 0, new Proizvod()));
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 1 || columnIndex == 2) {
            return true;
        }
        return false;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaRacuna stavka = racun.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0: //Ovo se ne menja
                    break;
            case 1: stavka.setProizvod((Proizvod)aValue);
                    stavka.setIznos(stavka.getKolicina() * stavka.getProizvod().getCena());
                    fireTableCellUpdated(rowIndex, 3);
                    break;
            case 2: stavka.setKolicina(Integer.parseInt((String)aValue));
                    stavka.setIznos(stavka.getKolicina() * stavka.getProizvod().getCena());
                    fireTableCellUpdated(rowIndex, 3);
                    break;
            case 3: //Ovo se ne menja
                    break;
        }
    }
    
    
    
}
