/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package komunikacija;

import domen.Korisnik;
import domen.Mesto;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.List;
import poslovnalogika.Kontroler;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;
import util.Konstante;

/**
 *
 * @author student1
 */
public class Komunikacija {
    private Socket socket;
    private boolean kraj = false;
    
    public void pokreniServer() throws IOException, ClassNotFoundException {
        ServerSocket ss = new ServerSocket(9000);
        System.out.println("Server je pokrenut.");
        socket = ss.accept();
        System.out.println("Klijent se povezao.");
        obradiZahteveKlijenta();
    }

    private void obradiZahteveKlijenta() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekatZahtev toZahtev = (TransferObjekatZahtev) inSocket.readObject();
            TransferObjekatOdgovor toOdgovor = new TransferObjekatOdgovor();
            try {
                switch(toZahtev.getOperacija()) {
                    case Konstante.VRATI_MESTA:
                        System.out.println("O: " + Konstante.VRATI_MESTA);
                        List<Mesto> lm = Kontroler.vratiObjekat().vratiMesta();
                        toOdgovor.setOdgovor(lm);
                        toOdgovor.setRezultat("Uspesno ucitana mesta.");
                        break;
                    case Konstante.SACUVAJ_KORISNIKA:
                        System.out.println("O: " + Konstante.SACUVAJ_KORISNIKA);
                        Korisnik k = (Korisnik) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajKorisnika(k);
                        toOdgovor.setRezultat("Uspesno sacuvan korisnik.");
                }
            } catch (Exception ex) {
                toOdgovor.setIzuzetak(ex);
                toOdgovor.setRezultat(ex.getMessage());
            }
            posaljiOdgovor(toOdgovor);
        }
    }

    private void posaljiOdgovor(TransferObjekatOdgovor toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }
    
    public static void main(String[] args) throws IOException, ClassNotFoundException {
        Komunikacija k = new Komunikacija();
        k.pokreniServer();
    }
    
}
