/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package komunikacija;

import domen.Korisnik;
import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import poslovnalogika.Kontroler;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;
import util.Konstante;

/**
 *
 * @author student1
 */
public class NitKlijent extends Thread {

    private Socket socket;
    private boolean kraj;

    public NitKlijent(Socket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        try {
            izvrsenjeOperacija();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekatZahtev toZahtev = (TransferObjekatZahtev) inSocket.readObject();
            TransferObjekatOdgovor toOdogovor = new TransferObjekatOdgovor();
            try {
                switch (toZahtev.getOperacija()) {
                    case Konstante.VRATI_MESTA:
                        System.out.println("O: " + Konstante.VRATI_MESTA);
                        List<OpstiDomenskiObjekat> lm = Kontroler.vratiObjekat().vratiMesta();
                        toOdogovor.setOdgovor(lm);
                        toOdogovor.setRezultat(Konstante.VRATI_MESTA_OK);
                        break;
                    case Konstante.SACUVAJ_KORISNIKA:
                        System.out.println("O: " + Konstante.SACUVAJ_KORISNIKA);
                        Korisnik k = (Korisnik) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajKorisnika(k);
                        toOdogovor.setRezultat(Konstante.SACUVAJ_KORISNIKA_OK);
                        break;
                    case Konstante.KRAJ:
                        kraj = true;
                        System.out.println("O: " + Konstante.KRAJ);
                        toOdogovor.setRezultat("Kraj rada!");
                        break;
                }
            } catch (Exception ex) {
                toOdogovor.setIzuzetak(ex);
                toOdogovor.setRezultat(ex.getMessage());
            }
            posaljiOdgovor(toOdogovor);
        }
    }

    private void posaljiOdgovor(TransferObjekatOdgovor toOdogovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdogovor);
    }

}
