/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package poslovnalogika;

import baza.DatabaseBroker;
import domen.Korisnik;
import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import domen.Proizvod;
import domen.Racun;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import poslovnalogika.so.korisnik.SacuvajKorisnikaSO;
import poslovnalogika.so.mesto.VratiMestaSO;


/**
 *
 * @author student1
 */
public class Kontroler {
    private KolekcijaKorisnika kk;
    private KolekcijaMesta km;
    private DatabaseBroker db;
    private static Kontroler kontroler;
    private Map<String, Object> mapa;

    private Kontroler() {
        kk = new KolekcijaKorisnika();
        km = new KolekcijaMesta();
        db = DatabaseBroker.getInstance();
        mapa = new HashMap<>();
    }
    
    public static Kontroler vratiObjekat() {
        if (kontroler == null) {
            kontroler = new Kontroler();
        }
        return kontroler;
    }
    
    public void dodajKorisnika(Korisnik k) {
        kk.dodajKorisnika(k);
    }
    
    public List<Korisnik> vratiKorisnike() throws RuntimeException {
        //return kk.vratiKorisnike();
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Korisnik> lk = db.vratiKorisnike();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lk;
    }
    
    public void dodajMesto(Mesto m) throws RuntimeException {
        //km.dodajMesto(m);
        db.ucitajDriver();
        db.otvoriKonekciju();
        db.sacuvajMesto(m);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }
    
    public List<OpstiDomenskiObjekat> vratiMesta() {
        VratiMestaSO soVratiMesta = new VratiMestaSO();
        soVratiMesta.izvrsiOperaciju(new Mesto());
        return soVratiMesta.getLista();
    }

    public Map<String, Object> getMapa() {
        return mapa;
    }
    
    public void sacuvajKorisnike(List<Korisnik> lk) throws RuntimeException {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            for (Korisnik k : lk) {
                db.sacuvajKorisnika(k);
                System.out.println("Sacuvao korisnika: " + k.getJMBG());
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }
    
    public List<Proizvod> vratiProizvode() throws RuntimeException {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Proizvod> lp = db.vratiProizvode();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lp;
    }
    
    public void sacuvajRacun(Racun r) throws RuntimeException {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            db.vratiSifruRacuna(r);
            db.sacuvajRacun(r);
            db.azurirajKolicineProizvoda(r);
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }

    public void sacuvajKorisnika(Korisnik k) throws RuntimeException {
        SacuvajKorisnikaSO soSacuvajKorisnika = new SacuvajKorisnikaSO();
        soSacuvajKorisnika.izvrsiOperaciju(k);
    }
    
}
