package poslovnalogika;

import baza.RadSaBazom;
import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import domen.Racun;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @author student1
 */
public class Kontroler {

    private KolekcijaKorisnika kolekcijaKorisnika;
    private static Kontroler objekatKontroler;
    private HashMap<String, Object> mapa;

    private Kontroler() {
        kolekcijaKorisnika = new KolekcijaKorisnika();
        mapa = new HashMap<>();
    }

    public static Kontroler vratiObjekatKontrolera() {
        if (objekatKontroler == null) {
            objekatKontroler = new Kontroler();
        }
        return objekatKontroler;
    }

    public KolekcijaKorisnika vratiKolekcijuKorisnika() {
        return kolekcijaKorisnika;
    }

    public void ubaciKorisnika(Korisnik korisnik) throws Exception {
        //kolekcijaKorisnika.ubaciNovogKorisnika(korisnik);
        //cuvanje podataka u bazi
        RadSaBazom rsb = new RadSaBazom();
        rsb.sacuvajKorisnika(korisnik);
    }

    public HashMap<String, Object> getMapa() {
        return mapa;
    }

    public List<Mesto> vratiSvaMesta() throws SQLException {
        return new RadSaBazom().vratiSvaMesta();
    }

    public List<Korisnik> vratiSveKorisnike() throws Exception {
        return new RadSaBazom().vratiSveKorisnike();
    }

    public void sacuvajKorisnike(List<Korisnik> listaKorisnika) {
        RadSaBazom rsb = new RadSaBazom();

        for (Korisnik korisnik : listaKorisnika) {
            try {
                rsb.sacuvajKorisnika(korisnik);
            } catch (Exception ex) {
                System.out.println("Korisnik sa sifrom " + korisnik.getKorisnickaSifra() + " postoji");
            }
        }

    }

    public void sacuvajKorisnikeCommit(List<Korisnik> listaKorisnika) throws SQLException {
        RadSaBazom rsb = new RadSaBazom();
        rsb.sacuvajKorisnike(listaKorisnika);
    }

    public List<Proizvod> vratiSveProizvode() throws Exception {
        RadSaBazom rsb = new RadSaBazom();
        return rsb.vratiSveProizvode();
    }

    public void sacuvajRacun(Racun racun) throws Exception {
        RadSaBazom rsb = new RadSaBazom();
        try {
            rsb.sacuvajRacun(racun);
        } catch (Exception ex) {
            throw ex;
        }
    }
}
