/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package logika.so;

import baza.DatabaseBroker;

/**
 *
 * @author student1
 */
public abstract class OpstaSO {
    public final void izvrsiOperaciju(Object obj) throws Exception {
        try {
            DatabaseBroker.getInstance().ucitajDriver();
            DatabaseBroker.getInstance().otvoriKonekciju();
            proveriPreduslov(obj);
            izvrsiKonkretnuOperaciju(obj);
            DatabaseBroker.getInstance().commitTransakcije();
        } catch (Exception ex) {
            DatabaseBroker.getInstance().rollbackTransakcije();
            throw ex;
        } finally {
            DatabaseBroker.getInstance().zatvoriKonekciju();
        }
    }

    protected abstract void proveriPreduslov(Object obj) throws Exception;

    protected abstract void izvrsiKonkretnuOperaciju(Object obj) throws Exception;
    
}
