package domen;

import java.io.Serializable;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 *
 * @author student1
 */
public class Mesto implements Serializable, OpstiDomenskiObjekat {
    long ptt;
    String naziv;
    
    public Mesto(){
        ptt = -1;
        naziv = "N/A";
    }

    public Mesto(long ptt, String naziv) {
        this.ptt = ptt;
        this.naziv = naziv;
    }
    

    public long getPtt() {
        return ptt;
    }

    public void setPtt(long ptt) {
        this.ptt = ptt;
    }

    public String getNaziv() {
        return naziv;
    }

    public void setNaziv(String naziv) {
        this.naziv = naziv;
    }

    @Override
    public String toString() {
        return naziv;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 41 * hash + (int) (this.ptt ^ (this.ptt >>> 32));
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Mesto other = (Mesto) obj;
        if (this.ptt != other.ptt) {
            return false;
        }
        return true;
    }

    @Override
    public String vratiNazivTabele() {
        return "Mesto";
    }

    @Override
    public List<OpstiDomenskiObjekat> vratiSve(ResultSet rs) throws Exception {
        List<OpstiDomenskiObjekat> lm = new ArrayList<>();
        while (rs.next()) {
            long ptt = rs.getLong("ptt");
            String naziv = rs.getString("naziv");
            Mesto m = new Mesto(ptt, naziv);
            lm.add(m);
        }
        return lm;
    }

    @Override
    public String vratiVrednostiZaInsert() {
        return ptt + ",'" + naziv + "'";
    }

    

    
    
    
    
}
