/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package komunikacija;

import domen.Korisnik;
import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import poslovnalogika.Kontroler;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;
import util.Konstante;

/**
 *
 * @author student1
 */
public class NitKlijent extends Thread {
    private Socket socket;
    private boolean kraj;

    public NitKlijent(Socket socket) {
        this.socket = socket;
        kraj = false;
    }
    
    

    @Override
    public void run() {
        try {
            obradiZahteveKlijenta();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        System.out.println("Nit zavrsava sa radom.");
    }
    
    private void obradiZahteveKlijenta() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekatZahtev toZahtev = (TransferObjekatZahtev) inSocket.readObject();
            TransferObjekatOdgovor toOdgovor = new TransferObjekatOdgovor();
            try {
                switch(toZahtev.getOperacija()) {
                    case Konstante.VRATI_MESTA:
                        System.out.println("O: " + Konstante.VRATI_MESTA);
                        List<OpstiDomenskiObjekat> lm = Kontroler.vratiObjekat().vratiMesta();
                        toOdgovor.setOdgovor(lm);
                        toOdgovor.setRezultat("Uspesno ucitana mesta.");
                        break;
                    case Konstante.SACUVAJ_KORISNIKA:
                        System.out.println("O: " + Konstante.SACUVAJ_KORISNIKA);
                        Korisnik k = (Korisnik) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajKorisnika(k);
                        toOdgovor.setRezultat("Uspesno sacuvan korisnik.");
                        break;
                    case Konstante.KRAJ:
                        kraj = true;
                        toOdgovor.setRezultat("Kraj rada");
                }
            } catch (Exception ex) {
                toOdgovor.setIzuzetak(ex);
                toOdgovor.setRezultat(ex.getMessage());
            }
            posaljiOdgovor(toOdgovor);
        }
    }

    private void posaljiOdgovor(TransferObjekatOdgovor toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }
    
}
