/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package baza;

import domen.Adresa;
import domen.Korisnik;
import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class DbKomunikacija {

    private Connection connection;

    public void ucitajDriver() throws RuntimeException {
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        } catch (ClassNotFoundException ex) {
            throw new RuntimeException("Driver nije pronadjen!");
        }
    }

    public void otvoriKonekciju() throws RuntimeException {
        try {
            connection = DriverManager.getConnection("jdbc:odbc:D1", "", "");
            connection.setAutoCommit(false); //zahteva elksplicitnu potvrdu transakcije
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesno otvaranje konekcije!");
        }
    }

    public void commitTransakcije() throws RuntimeException {
        try {
            connection.commit();
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesan commit!");
        }
    }

    public void rollbackTransakcije() throws RuntimeException {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesan rollback!");
        }
    }
    
    public void sacuvajODO(OpstiDomenskiObjekat odo) throws RuntimeException {
        try {
            String sql = "INSERT INTO "+odo.vratiNazivTabele()+" VALUES (" +odo.vratiVrednostiAtributaZaInsert() +")";
            System.out.println("upit:"+sql);                                                                                                                                                
            Statement sqlNaredba = connection.createStatement();
            sqlNaredba.executeUpdate(sql);
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesno cuvanje mesta! " + ex.getMessage());
        }
    }


    public void sacuvajMesto(Mesto mesto) throws RuntimeException {
        try {
            String sql = "INSERT INTO Mesto VALUES (" + mesto.getPtt() + ",'" + mesto.getNaziv() + "')";
            Statement sqlNaredba = connection.createStatement();
            sqlNaredba.executeUpdate(sql);
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesno cuvanje mesta! " + ex.getMessage());
        }
    }

    public void zatvoriKonekciju() throws RuntimeException {
        try {
            connection.close();
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesno zatvaranje konekcije!");
        }
    }

    public List vratiSveObjekte(OpstiDomenskiObjekat odo){
        try {
            Statement sqlNaredba = connection.createStatement();
            String sql = "SELECT * FROM "+odo.vratiFromKlauzuluZaSelect();
            System.out.println("upit:"+sql);
            ResultSet rs = sqlNaredba.executeQuery(sql);
            List lm = new ArrayList<>();
            lm = odo.napuniIVratiSveObjekte(rs);
            return lm;
        } catch (Exception ex) {
            throw new RuntimeException("Neuspesno ucitavanje mesta!");
        }
                
    }
    
    public List<Mesto> vratiMesta() throws RuntimeException {
        try {
            Statement sqlNaredba = connection.createStatement();
            String sql = "SELECT * FROM Mesto";
            ResultSet rs = sqlNaredba.executeQuery(sql);
            List<Mesto> lm = new ArrayList<>();
            while (rs.next()) {
                Mesto m = new Mesto();
                m.setPtt(rs.getLong("Ptt"));
                m.setNaziv(rs.getString(2));
                lm.add(m);
            }
            return lm;
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesno ucitavanje mesta!");
        }
    }

    public void sacuvajKorisnika(Korisnik k) throws RuntimeException {
        try {
            String sql = "INSERT INTO Korisnik VALUES (?,?,?,?,?,?,?,?)";
            PreparedStatement sqlNaredba = connection.prepareStatement(sql);
            sqlNaredba.setString(1, k.getJMBG());
            sqlNaredba.setString(2, k.getIme());
            sqlNaredba.setString(3, k.getPrezime());
            sqlNaredba.setString(4, k.getKorisnickoIme());
            sqlNaredba.setString(5, k.getKorisnickaLozinka());
            sqlNaredba.setString(6, k.getAdresa().getNazivUlice());
            sqlNaredba.setString(7, k.getAdresa().getBroj());
            //sqlNaredba.setLong(8, k.getAdresa().getMesto().getPtt());
            sqlNaredba.setBigDecimal(8, new BigDecimal(k.getAdresa().getMesto().getPtt()));
            sqlNaredba.executeUpdate();
            sqlNaredba.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new RuntimeException("Neuspesno cuvanje korisnika!");
        }

    }

    public List<Korisnik> vratiKorisnike() throws RuntimeException {
        try {
            String sql = "SELECT * FROM Korisnik k INNER JOIN Mesto m ON (k.Ptt=m.Ptt)";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rs = sqlNaredba.executeQuery(sql);
            List<Korisnik> lk = new ArrayList<>();
            while (rs.next()) {
                Korisnik k = new Korisnik();
                k.setJMBG(rs.getString("JMBG"));
                k.setIme(rs.getString("Ime"));
                k.setPrezime(rs.getString("Prezime"));
                k.setKorisnickoIme(rs.getString("KorisnickoIme"));
                k.setKorisnickaLozinka(rs.getString("KorisnickaLozinka"));
                k.getAdresa().setBroj(rs.getString("Broj"));
                k.getAdresa().setNazivUlice(rs.getString("NazivUlice"));
                Mesto m = new Mesto();
                m.setPtt(rs.getLong(8));
                m.setNaziv(rs.getString("Naziv"));
                k.getAdresa().setMesto(m);

                lk.add(k);
            }
            return lk;
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new RuntimeException("Neuspesno ucitavanje korisnika!");
        }
    }

    public List<Proizvod> vratiProizvode() throws RuntimeException {
        try {
            List<Proizvod> lp = new ArrayList<>();
            String sql = "SELECT * FROM Proizvod";
            Statement st = connection.createStatement();
            ResultSet rs = st.executeQuery(sql);
            while (rs.next()) {
                Proizvod p = new Proizvod();
                p.setProizvodID(rs.getInt("ProizvodID"));
                p.setNaziv(rs.getString("Naziv"));
                p.setCena(rs.getDouble("Cena"));
                p.setKolicinaNaStanju(rs.getInt("KolicinaNaStanju"));
                lp.add(p);
            }
            return lp;
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new RuntimeException("Neuspesno ucitavanje proizvoda!");
        }
    }

    public void sacuvajRacun(Racun r) throws RuntimeException {
        try {
            String sql = "INSERT INTO Racun VALUES (?,?,?,?)";
            PreparedStatement sqlNaredba = connection.prepareStatement(sql);
            sqlNaredba.setInt(1, r.getRacunID());
            sqlNaredba.setDate(2, new java.sql.Date(r.getDatum().getTime()));
            sqlNaredba.setDouble(3, r.getUkupanIznos());
            sqlNaredba.setString(4, r.getKorisnik().getJMBG());
            sqlNaredba.executeUpdate();

            sql = "INSERT INTO StavkaRacuna VALUES(?,?,?,?,?)";
            sqlNaredba = connection.prepareStatement(sql);
            for (StavkaRacuna s : r.getListaStavki()) {
                sqlNaredba.setInt(1, r.getRacunID());
                sqlNaredba.setInt(2, s.getRbStavke());
                sqlNaredba.setInt(3, s.getKolicina());
                sqlNaredba.setDouble(4, s.getIznos());
                sqlNaredba.setInt(5, s.getProizvod().getProizvodID());
                sqlNaredba.executeUpdate();
            }
            sqlNaredba.close();

        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new RuntimeException("Neuspesno cuvanje racuna!");
        }
    }

    public void vratiSifruRacuna(Racun r) throws RuntimeException {
        try {
            String sql = "SELECT MAX(RacunID) AS Sifra FROM Racun";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rs = sqlNaredba.executeQuery(sql);
            int racunID = 0;
            if (rs.next()) {
                racunID = rs.getInt("Sifra");
            }
            racunID++;
            r.setRacunID(racunID);
            rs.close();
            sqlNaredba.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new RuntimeException("Neuspesno generisanje sifre racuna!");
        }
    }

    public void azurirajKolicineProizvoda(Racun r) throws RuntimeException {
        try {
            String sql = "UPDATE Proizvod SET KolicinaNaStanju = ? WHERE ProizvodID = ?";
            PreparedStatement sqlNaredba = connection.prepareStatement(sql);
            for (StavkaRacuna s : r.getListaStavki()) {
                Proizvod p = s.getProizvod();
                int novaKolicina = p.getKolicinaNaStanju() - s.getKolicina();
                if (novaKolicina < 0) {
                    throw new RuntimeException("Nedozvoljena kolicina: " + p.getNaziv()
                            + "; Raspolozivo: " + p.getKolicinaNaStanju());
                }
                sqlNaredba.setInt(1, novaKolicina);
                sqlNaredba.setInt(2, p.getProizvodID());
                sqlNaredba.executeUpdate();
            }

        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new RuntimeException("Neuspesno azuriranje kolicina!");
        }
    }

}
