/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package niti;

import domen.Korisnik;
import domen.Mesto;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import komunikacija.Komunikacija;
import poslovnalogika.Kontroler;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;
import util.Konstante;

/**
 *
 * @author student1
 */
public class NitObradaKlijenata extends Thread {

    Socket socket;
    private boolean kraj = false;
    ObjectInputStream inSocket;
    ObjectOutputStream outSocket;
    ArrayList ulogovaniKorisnici;

    public NitObradaKlijenata(Socket socket, ArrayList ulogovaniKorisnici) {
        try {
            this.socket = socket;
            inSocket = new ObjectInputStream(socket.getInputStream());
            outSocket = new ObjectOutputStream(socket.getOutputStream());
            this.ulogovaniKorisnici = ulogovaniKorisnici;

        } catch (IOException ex) {
            Logger.getLogger(NitObradaKlijenata.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    public void run() {
        try {
            izvrsenjeOperacija();

        } catch (IOException ex) {
            Logger.getLogger(NitObradaKlijenata.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(NitObradaKlijenata.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (!kraj) {

            TransferObjekatZahtev toZahtev = (TransferObjekatZahtev) inSocket.readObject();
            TransferObjekatOdgovor toOdogovor = new TransferObjekatOdgovor();
            try {
                switch (toZahtev.getOperacija()) {
                    case Konstante.VRATI_MESTA:
                        System.out.println("O: " + Konstante.VRATI_MESTA);
                        List<Mesto> lm = Kontroler.vratiObjekat().vratiMesta();
                        toOdogovor.setOdgovor(lm);
                        toOdogovor.setRezultat(Konstante.VRATI_MESTA_OK);
                        break;
                    case Konstante.SACUVAJ_KORISNIKA:
                        System.out.println("O: " + Konstante.SACUVAJ_KORISNIKA);
                        Korisnik k = (Korisnik) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajKorisnika(k);
                        toOdogovor.setRezultat(Konstante.SACUVAJ_KORISNIKA_OK);
                        break;
                    case Konstante.VRATI_SVE_KORISNIKE:
                        
                        List<Korisnik> lk = Kontroler.vratiObjekat().vratiKorisnike();
                        toOdogovor.setOdgovor(lk);
                        toOdogovor.setRezultat(Konstante.VRATI_SVE_KORISNIKE_OK);
                        break;
                }
            } catch (Exception ex) {
                toOdogovor.setIzuzetak(ex);
                toOdogovor.setRezultat(ex.getMessage());
            }
            posaljiOdgovor(toOdogovor);
        }
    }

    private void posaljiOdgovor(TransferObjekatOdgovor toOdogovor) throws IOException {

        outSocket.writeObject(toOdogovor);
    }

}
