/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package poslovnalogika;

import baza.DbKomunikacija;
import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import domen.Racun;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import so.SacuvajKorisnika;
import so.VratiSvaMesta;
import so.VratiSveKorisnike;


/**
 *
 * @author student1
 */
public class Kontroler {
    private KolekcijaKorisnika kk;
    private KolekcijaMesta km;
    private DbKomunikacija db;
    private static Kontroler kontroler;
    private Map<String, Object> mapa;

    private Kontroler() {
        kk = new KolekcijaKorisnika();
        km = new KolekcijaMesta();
        db = new DbKomunikacija();
        mapa = new HashMap<>();
    }
    
    public static Kontroler vratiObjekat() {
        if (kontroler == null) {
            kontroler = new Kontroler();
        }
        return kontroler;
    }
    
    public void dodajKorisnika(Korisnik k) {
        kk.dodajKorisnika(k);
    }
    
    public List<Korisnik> vratiKorisnike() throws RuntimeException {
        //return kk.vratiKorisnike();
//        db.ucitajDriver();
//        db.otvoriKonekciju();
////        List<Korisnik> lk = db.vratiKorisnike();
//        db.commitTransakcije();
//        db.zatvoriKonekciju();
        
        VratiSveKorisnike vsk = new VratiSveKorisnike();
        vsk.opsteIzvrsenjeSO(new Korisnik());
        List listaKorisnika=vsk.getListaKorisnika();
        return listaKorisnika;
    }
    
    public void dodajMesto(Mesto m) throws RuntimeException {
        //km.dodajMesto(m);
        db.ucitajDriver();
        db.otvoriKonekciju();
        //db.sacuvajMesto(m);
        db.sacuvajODO(m);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }
    
    public List<Mesto> vratiMesta() {
//        //return km.vratiMesta();
//        db.ucitajDriver();
//        db.otvoriKonekciju();
//        List<Mesto> lm = db.vratiSveObjekte(new Mesto());
//        db.commitTransakcije();
//        db.zatvoriKonekciju();
//        return lm;
          VratiSvaMesta soVratiSvaMesta = new VratiSvaMesta();
          soVratiSvaMesta.opsteIzvrsenjeSO(new Mesto());
          return soVratiSvaMesta.getListaMesta();
    }

    public Map<String, Object> getMapa() {
        return mapa;
    }
    
    public void sacuvajKorisnike(List<Korisnik> lk) throws RuntimeException {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            for (Korisnik k : lk) {
                db.sacuvajKorisnika(k);
                System.out.println("Sacuvao korisnika: " + k.getJMBG());
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }
    
    public List<Proizvod> vratiProizvode() throws RuntimeException {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Proizvod> lp = db.vratiProizvode();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lp;
    }
    
    public void sacuvajRacun(Racun r) throws RuntimeException {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            db.vratiSifruRacuna(r);
            db.sacuvajRacun(r);
            db.azurirajKolicineProizvoda(r);
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }

    public void sacuvajKorisnika(Korisnik k) throws RuntimeException {
//            db.ucitajDriver();
//            db.otvoriKonekciju();
//            //db.sacuvajKorisnika(k);
//            db.sacuvajODO(k);
//            db.commitTransakcije();
//            db.zatvoriKonekciju();
        SacuvajKorisnika soSacuvajKorisnika = new SacuvajKorisnika();
        soSacuvajKorisnika.opsteIzvrsenjeSO(k);
        
    }
    
}
