package poslovnalogika;

//import baza.RadSaBazom;
import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import domen.Racun;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import transfer.TOKlijentZahtev;
import transfer.TOServerOdgovor;
import util.Util;

/**
 *
 * @author student1
 */
public class Kontroler {

    private KolekcijaKorisnika kolekcijaKorisnika;
    private static Kontroler objekatKontroler;
    private HashMap<String, Object> mapa;
    private Socket soket;

    private Kontroler() {
        kolekcijaKorisnika = new KolekcijaKorisnika();
        mapa = new HashMap<>();
    }

    public static Kontroler vratiObjekatKontrolera() {
        if (objekatKontroler == null) {
            objekatKontroler = new Kontroler();
        }
        return objekatKontroler;
    }

    public KolekcijaKorisnika vratiKolekcijuKorisnika() {
        return kolekcijaKorisnika;
    }

    public void ubaciKorisnika(Korisnik korisnik) throws Exception {
        TOKlijentZahtev zahtev = new TOKlijentZahtev();
        zahtev.setOperacija(Util.OPERACIJA_UBACI_KORISNIKA);
        zahtev.setParametar(korisnik);
        ObjectOutputStream out = new ObjectOutputStream(soket.getOutputStream());
        out.writeObject(zahtev);       
        ObjectInputStream in = new ObjectInputStream(soket.getInputStream());
        TOServerOdgovor odgovor = (TOServerOdgovor) in.readObject();
        int status = odgovor.getStatusIzvrsenjaOperacije();
        if (status == Util.STATUS_IZVRSENJA_OPERACIJE_OK) {
             odgovor.getRezultat();
        } else {
            throw new Exception(odgovor.getPoruka());
        }
//kolekcijaKorisnika.ubaciNovogKorisnika(korisnik);
        //cuvanje podataka u bazi
//        RadSaBazom rsb = new RadSaBazom();
//        rsb.sacuvajKorisnika(korisnik);
    }

    public HashMap<String, Object> getMapa() {
        return mapa;
    }

    public List<Mesto> vratiSvaMesta() throws Exception {
//        return new RadSaBazom().vratiSvaMesta();
        TOKlijentZahtev zahtev = new TOKlijentZahtev();
        zahtev.setOperacija(Util.OPERACIJA_VRATI_SVA_MESTA);
        ObjectOutputStream out = new ObjectOutputStream(soket.getOutputStream());
        out.writeObject(zahtev);
        ObjectInputStream in = new ObjectInputStream(soket.getInputStream());
        TOServerOdgovor odgovor = (TOServerOdgovor) in.readObject();
        int status = odgovor.getStatusIzvrsenjaOperacije();
        if (status == Util.STATUS_IZVRSENJA_OPERACIJE_OK) {
            return (List<Mesto>) odgovor.getRezultat();
        } else {
            throw new Exception(odgovor.getPoruka());
        }
        //return new ArrayList<>();
    }

    public List<Korisnik> vratiSveKorisnike() throws Exception {
        //return new RadSaBazom().vratiSveKorisnike();
        return new ArrayList<>();
    }

    public void sacuvajKorisnike(List<Korisnik> listaKorisnika) {
//        RadSaBazom rsb = new RadSaBazom();
//
//        for (Korisnik korisnik : listaKorisnika) {
//            try {
//                rsb.sacuvajKorisnika(korisnik);
//            } catch (Exception ex) {
//                System.out.println("Korisnik sa sifrom " + korisnik.getKorisnickaSifra() + " postoji");
//            }
//        }

    }

    public void sacuvajKorisnikeCommit(List<Korisnik> listaKorisnika) throws SQLException {
//        RadSaBazom rsb = new RadSaBazom();
//        rsb.sacuvajKorisnike(listaKorisnika);
    }

    public List<Proizvod> vratiSveProizvode() throws Exception {
//        RadSaBazom rsb = new RadSaBazom();
//        return rsb.vratiSveProizvode();
        return new ArrayList<>();
    }

    public void sacuvajRacun(Racun racun) throws Exception {
//        RadSaBazom rsb = new RadSaBazom();
//        rsb.sacuvajRacun(racun);
    }

    public void postaviSoket(Socket ksoket) {
        soket = ksoket;
    }
}
