package baza;

import domen.Adresa;
import domen.Korisnik;
import domen.Mesto;
import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student1
 */
public class RadSaBazom {

    public void sacuvajMesto(Mesto m) throws ClassNotFoundException, SQLException {
        //ucitaj odgovarajuci driver
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        //uspostavi konekciju ka bazi
        Connection konekcija = DriverManager.getConnection("jdbc:odbc:D2");
        //validan upit koji treba da se izvrsi
        String upit = "INSERT INTO Mesto VALUES (" + m.getPtt() + ", '" + m.getNaziv() + "')";
        Statement s = konekcija.createStatement();
        s.executeUpdate(upit);
        System.out.println("Uspesno je odradjena operacija");
        konekcija.close();

    }

    public void sacuvajMesto_(Mesto m) throws ClassNotFoundException, SQLException {
        //ucitaj odgovarajuci driver
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        //uspostavi konekciju ka bazi
        Connection konekcija = DriverManager.getConnection("jdbc:odbc:D2");
        //validan upit koji treba da se izvrsi
        String upit = "INSERT INTO Mesto VALUES (?,?)";
        PreparedStatement ps = konekcija.prepareStatement(upit);
        ps.setBigDecimal(1, new BigDecimal(m.getPtt()));
        ps.setString(2, m.getNaziv());
        ps.executeUpdate();
        System.out.println("Uspesno je odradjena operacija");
        konekcija.close();

    }

    public List<Mesto> vratiSvaMesta() throws SQLException {
        List<Mesto> listaMesta = new ArrayList<>();
        Connection konekcija = DriverManager.getConnection("jdbc:odbc:D2");
        String upit = "SELECT * FROM Mesto ORDER BY naziv";
        Statement s = konekcija.createStatement();
        ResultSet rs = s.executeQuery(upit);
        while (rs.next()) {
            long ptt = rs.getLong("ptt");
            String naziv = rs.getString("naziv");
            Mesto m = new Mesto(ptt, naziv);
            listaMesta.add(m);
        }
        konekcija.close();
        return listaMesta;
    }

    public void sacuvajKorisnika(Korisnik k) throws Exception {
        Connection konekcija = null;
        try {
            konekcija = DriverManager.getConnection("jdbc:odbc:D2");
            String upit = "INSERT INTO Korisnik VALUES (?,?,?,?,?,?,?,?)";
            PreparedStatement ps = konekcija.prepareStatement(upit);
            ps.setString(1, k.getKorisnickoIme());
            ps.setString(2, k.getKorisnickaSifra());
            ps.setString(3, k.getIme());
            ps.setString(4, k.getPrezime());
            ps.setString(5, k.getJMBG());
            ps.setString(6, k.getAdresa().getNazivUlice());
            ps.setString(7, k.getAdresa().getBroj());
            ps.setBigDecimal(8,
                    new BigDecimal(k.getAdresa().getMesto().getPtt()));
            ps.executeUpdate();

        } catch (Exception ex) {
            ex.printStackTrace();          
            throw new Exception();
        } finally {
            if (konekcija != null) {
                konekcija.close();
            }
        }
    }

    public List<Korisnik> vratiSveKorisnike() throws Exception {
        List<Korisnik> listaKorisnika = new ArrayList<>();
        Connection konekcija = null;
        try {
            konekcija = DriverManager.getConnection("jdbc:odbc:D2");
            String upit = "SELECT Korisnik.korisnickoime, Korisnik.korisnickasifra, Korisnik.ime, Mesto.naziv AS nazivmesta, Korisnik.prezime, Korisnik.jmbg, Korisnik.nazivulice, Korisnik.broj, Korisnik.ptt FROM Mesto INNER JOIN Korisnik ON Mesto.ptt = Korisnik.ptt ORDER BY Korisnik.prezime";
            Statement s = konekcija.createStatement();
            ResultSet rs = s.executeQuery(upit);
            while (rs.next()) {
                Korisnik k = new Korisnik();
                k.setKorisnickoIme(rs.getString("korisnickoime"));
                k.setKorisnickaSifra(rs.getString("korisnickasifra"));
                k.setIme(rs.getString("ime"));
                k.setPrezime(rs.getString("prezime"));
                k.setJMBG(rs.getString("jmbg"));

                Adresa adresa = new Adresa();
                adresa.setNazivUlice(rs.getString("nazivulice"));
                adresa.setBroj(rs.getString("broj"));

                Mesto mesto = new Mesto();
                mesto.setPtt(rs.getLong("ptt"));
                mesto.setNaziv(rs.getString("nazivmesta"));
                adresa.setMesto(mesto);

                k.setAdresa(adresa);
                listaKorisnika.add(k);
            }
            return listaKorisnika;
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception();
        } finally {
            if (konekcija != null) {
                konekcija.close();
            }
        }
    }

    public void sacuvajKorisnike(List<Korisnik> listaKorisnika) throws SQLException {
        Connection konekcija = null;
        try {
            konekcija = DriverManager.getConnection("jdbc:odbc:D2");
            konekcija.setAutoCommit(false);
            String upit = "INSERT INTO Korisnik VALUES (?,?,?,?,?,?,?,?)";
            PreparedStatement ps = konekcija.prepareStatement(upit);
            for (Korisnik k : listaKorisnika) {
                ps.setString(1, k.getKorisnickoIme());
                ps.setString(2, k.getKorisnickaSifra());
                ps.setString(3, k.getIme());
                ps.setString(4, k.getPrezime());
                ps.setString(5, k.getJMBG());
                ps.setString(6, k.getAdresa().getNazivUlice());
                ps.setString(7, k.getAdresa().getBroj());
                ps.setBigDecimal(8,
                        new BigDecimal(k.getAdresa().getMesto().getPtt()));
                ps.executeUpdate();
            }
            konekcija.commit();
        } catch (SQLException ex) {
            if (konekcija != null) {
                konekcija.rollback();
            }
            throw new SQLException();
        } catch (Exception e) {

        } finally {
            if (konekcija != null) {
                konekcija.close();
            }
        }
    }

    public List<Proizvod> vratiSveProizvode() throws Exception {
        List<Proizvod> listaProizvoda = new ArrayList<>();
        Connection konekcija = null;
        try {
            konekcija = DriverManager.getConnection("jdbc:odbc:D2");
            String upit = "SELECT * FROM Proizvod";
            Statement s = konekcija.createStatement();
            ResultSet rs = s.executeQuery(upit);
            while (rs.next()) {
                Proizvod proizvod = new Proizvod();
                proizvod.setCena(rs.getDouble("cena"));
                proizvod.setSifraProizvoda(rs.getLong("sifraProizvoda"));
                proizvod.setNaziv(rs.getString("nazivProizvoda"));
                listaProizvoda.add(proizvod);
            }
            return listaProizvoda;
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception();
        } finally {
            if (konekcija != null) {
                konekcija.close();
            }
        }
    }

    public void sacuvajRacun(Racun racun) throws Exception{
        Connection konekcija = null;
        try{
            konekcija = DriverManager.getConnection("jdbc:odbc:D2");
            konekcija.setAutoCommit(false);
            
            String upit = "INSERT INTO Racun VALUES(?,?,?,?)";
            PreparedStatement ps = konekcija.prepareStatement(upit);
            ps.setString(1, racun.getBrojRacuna());
            ps.setDate(2, new Date(racun.getDatum().getTime()));
            ps.setString(3, racun.getKorisnik().getKorisnickoIme());
            ps.setDouble(4, racun.getUkupanIznos());
            
            ps.executeUpdate();
            //sacuvajStavke
            
            upit = "INSERT INTO StavkaRacuna VALUES(?,?,?,?,?)";
            ps = konekcija.prepareStatement(upit);
            
            for(StavkaRacuna sr:racun.getListaStavki()){
                ps.setString(1, sr.getRacun().getBrojRacuna());
                ps.setBigDecimal(2, new BigDecimal(sr.getRedniBroj()));
                ps.setBigDecimal(3, new BigDecimal(sr.getProizvod().getSifraProizvoda()));
                ps.setDouble(4, sr.getCena());
                ps.setDouble(5, sr.getKolicina());
                
                ps.executeUpdate();
                
            }
            konekcija.commit();
        }
        catch(Exception e){
            if(konekcija != null){
                konekcija.rollback();
            }
            throw new Exception("Racun nije sacuvan!");
        }
        finally{
            konekcija.close();
        }
    }

    public void sacuvajKorisnika(Object parametar) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
}
