package poslovnalogika;

import baza.KomunikacijaSaBazom;
import domen.Korisnik;
import domen.Mesto;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @author student1
 */
public class Kontroler {
    private KolekcijaKorisnika kolekcijaKorisnika;
    private static Kontroler objekatKontroler;
    private HashMap <String, Object> mapa;
    
    private Kontroler() {
        kolekcijaKorisnika = new KolekcijaKorisnika();
        mapa=new HashMap<>();
    }
    
    public void ubaciKorisnika(Korisnik korisnik){
        kolekcijaKorisnika.ubaciNovogKorisnika(korisnik);
    }
    
    public static Kontroler vratiObjekatKontrolera(){
        if (objekatKontroler==null) {
            objekatKontroler = new Kontroler();
        }
        return objekatKontroler;
    }
    
    public KolekcijaKorisnika vratiKolekcijuKorisnika(){
        return kolekcijaKorisnika;
    }

    public HashMap<String, Object> getMapa() {
        return mapa;
    }
    public void sacuvajKorisnike(List<Korisnik> listaKorisnika) throws SQLException {
        KomunikacijaSaBazom ksb = new KomunikacijaSaBazom();
        ksb.sacuvajSveKorisnike(listaKorisnika);
    }

    public List<Mesto> vratiSvaMesta() {
        KomunikacijaSaBazom ksb = new KomunikacijaSaBazom();
        try {
            return ksb.vratiSvaMesta();
        } catch (Exception e) {
            e.printStackTrace();
            return new ArrayList<>();
        }
    }
    
}
