/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package db;

import domen.Adresa;
import domen.Artikal;
import domen.Korisnik;
import domen.Mesto;
import domen.Racun;
import domen.StavkaRacuna;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student1
 */
public class DatabaseBroker {
    private Connection konekcija;
    
    public void uspostaviKonekciju() throws ClassNotFoundException, SQLException{
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        String url="jdbc:odbc:bazaKorisnika";
        String user="";
        String password="";
        konekcija=DriverManager.getConnection(url, user, password);
        konekcija.setAutoCommit(false);
    }
    
    public void zatvoriKonekciju() throws SQLException{
        konekcija.close();
    }
    
    public void commitTransakcije() throws SQLException{
        konekcija.commit();
    }
    
    public void rollbackTransakcije() throws SQLException{
        konekcija.rollback();
    }
    
    public List<Mesto> vratiSvaMesta() throws SQLException{
        List<Mesto> mesta=new ArrayList<>();
        String upit="SELECT pttBroj, naziv FROM Mesto";
        Statement statement=konekcija.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            Mesto mesto=new Mesto();
            mesto.setPttBroj(rs.getInt("pttBroj"));
            mesto.setNaziv(rs.getString("naziv"));
            mesta.add(mesto);
        }
        rs.close();
        statement.close();
        return mesta;
    }
    
    public void kreirajNovogKorisnika(Korisnik korisnik) throws SQLException{
        String upit="INSERT INTO Korisnik (jmbg, ime, prezime, korisnickoIme, lozinka, ulica, broj, pttBroj) "
                + "VALUES ('"+korisnik.getJmbg()+"','"
                +korisnik.getIme()+"','"
                +korisnik.getPrezime()+"','"
                +korisnik.getKorisnickoIme()+"','"
                +korisnik.getLozinka()+"','"
                +korisnik.getAdresa().getUlica()+"','"
                +korisnik.getAdresa().getBroj()+"',"
                +korisnik.getAdresa().getMesto().getPttBroj()+")";
        Statement statement=konekcija.createStatement();
        statement.executeUpdate(upit);
        statement.close();
    }
    
    public void kreirajNovogKorisnikaBoljiNacin(Korisnik korisnik) throws SQLException{
        String upit="INSERT INTO Korisnik (jmbg, ime, prezime, korisnickoIme, lozinka, ulica, broj, pttBroj) "
                + "VALUES (?,?,?,?,?,?,?,?)";
        PreparedStatement preparedStatement=konekcija.prepareStatement(upit);
        preparedStatement.setString(1, korisnik.getJmbg());
        preparedStatement.setString(2, korisnik.getIme());
        preparedStatement.setString(3, korisnik.getPrezime());
        preparedStatement.setString(4, korisnik.getKorisnickoIme());
        preparedStatement.setString(5, korisnik.getLozinka());
        preparedStatement.setString(6, korisnik.getAdresa().getUlica());
        preparedStatement.setString(7, korisnik.getAdresa().getBroj());
        preparedStatement.setInt(8, korisnik.getAdresa().getMesto().getPttBroj());
        preparedStatement.executeUpdate();
        preparedStatement.close();
    }
    
    public List<Korisnik> vratiSveKorisnike() throws SQLException{
        List<Korisnik> korisnici=new ArrayList<>();
        String upit="SELECT jmbg, ime, prezime, korisnickoIme, lozinka, ulica, broj, Mesto.pttBroj, Mesto.naziv "
                + "FROM Korisnik INNER JOIN Mesto ON Korisnik.pttBroj=Mesto.pttBroj";
        Statement statement=konekcija.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            Korisnik korisnik=new Korisnik();
            korisnik.setJmbg(rs.getString("jmbg"));
            korisnik.setIme(rs.getString("ime"));
            korisnik.setPrezime(rs.getString("prezime"));
            korisnik.setKorisnickoIme(rs.getString("korisnickoIme"));
            korisnik.setLozinka(rs.getString("lozinka"));
            Adresa adresa=new Adresa();
            adresa.setUlica(rs.getString("ulica"));
            adresa.setBroj(rs.getString("broj"));
            Mesto mesto=new Mesto();
            mesto.setPttBroj(rs.getInt("pttBroj"));
            mesto.setNaziv(rs.getString("naziv"));
            adresa.setMesto(mesto);
            korisnik.setAdresa(adresa);
            korisnici.add(korisnik);
        }
        rs.close();
        statement.close();
        return korisnici;
    }
    
    public List<Artikal> vratiSveArtikle() throws SQLException{
        List<Artikal> artikli=new ArrayList<>();
        String upit="SELECT artikalID, naziv, cena FROM Artikal";
        Statement statement=konekcija.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            Artikal artikal=new Artikal();
            artikal.setArtikalID(rs.getInt("artikalID"));
            artikal.setNaziv(rs.getString("naziv"));
            artikal.setCena(rs.getDouble("cena"));
            artikli.add(artikal);
        }
        rs.close();
        statement.close();
        return artikli;
    }

    public void kreirajNoviRacun(Racun racun) throws Exception{
        String upit="INSERT INTO Racun (racunID, datum, ukupanIznos, jmbg) "
                + "VALUES (?,?,?,?)";
        PreparedStatement preparedStatement=konekcija.prepareStatement(upit);
        preparedStatement.setInt(1, racun.getRacunID());
        preparedStatement.setDate(2, new Date(racun.getDatum().getTime()));
        preparedStatement.setDouble(3, racun.getUkupanIznos());
        preparedStatement.setString(4, racun.getKorisnik().getJmbg());
        preparedStatement.executeUpdate();
        preparedStatement.close();
    }

    public void kreirajNovuStavkuRacuna(StavkaRacuna stavkaRacuna) throws Exception{
        String upit="INSERT INTO StavkaRacuna (racunID, rbStavke, artikalID, kolicina, iznos) "
                + "VALUES (?,?,?,?,?)";
        PreparedStatement preparedStatement=konekcija.prepareStatement(upit);
        preparedStatement.setInt(1, stavkaRacuna.getRacun().getRacunID());
        preparedStatement.setInt(2, stavkaRacuna.getRbStavke());
        preparedStatement.setInt(3, stavkaRacuna.getArtikal().getArtikalID());
        preparedStatement.setDouble(4, stavkaRacuna.getKolicina());
        preparedStatement.setDouble(5, stavkaRacuna.getIznos());
        preparedStatement.executeUpdate();
        preparedStatement.close();
    }
}
