/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package view.model;

import domen.Korisnik;
import domen.Mesto;
import java.util.ArrayList;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelKorisnici extends AbstractTableModel{
    private List<Korisnik> korisnici;
    private String[] naziviKolona=new String[]{"JMBG","Ime","Prezime","Korisnicko ime","Lozinka","Ulica","Broj","Mesto"};
    private boolean editabilna=false;
    
    public TableModelKorisnici(List<Korisnik> korisnici, boolean editabilna){
        if(korisnici==null){
            korisnici=new ArrayList<>();
        }
        this.korisnici=korisnici;
        this.editabilna=editabilna;
    }

    @Override
    public String getColumnName(int column) {
        return naziviKolona[column];
    }

    @Override
    public int getRowCount() {
        return korisnici.size();
    }

    @Override
    public int getColumnCount() {
        return naziviKolona.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Korisnik korisnik=korisnici.get(rowIndex);
        switch (columnIndex){
            case 0: return korisnik.getJmbg();
            case 1: return korisnik.getIme();
            case 2: return korisnik.getPrezime();
            case 3: return korisnik.getKorisnickoIme();
            case 4: return korisnik.getLozinka();
            case 5: return korisnik.getAdresa().getUlica();
            case 6: return korisnik.getAdresa().getBroj();
            case 7: return korisnik.getAdresa().getMesto();
                
            default: return "N/A";
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        Korisnik korisnik=korisnici.get(rowIndex);
        switch (columnIndex){
            case 0: korisnik.setJmbg(aValue.toString()); break;
            case 1: korisnik.setIme(aValue.toString()); break;
            case 2: korisnik.setPrezime(aValue.toString()); break;
            case 3: korisnik.setKorisnickoIme(aValue.toString()); break;
            case 4: korisnik.setLozinka(aValue.toString()); break;
            case 5: korisnik.getAdresa().setUlica(aValue.toString()); break;
            case 6: korisnik.getAdresa().setBroj(aValue.toString()); break;
            case 7: korisnik.getAdresa().setMesto((Mesto)aValue); break;
        }
    }
   

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return editabilna; //To change body of generated methods, choose Tools | Templates.
    }
    
    
    
    public void dodajKorisnika(Korisnik korisnik){
        korisnici.add(korisnik);
        fireTableDataChanged();
    }
    
    public void obrisiKorisnika(int rowIndex){
        Korisnik korisnik=korisnici.get(rowIndex);
        korisnici.remove(korisnik);
        fireTableDataChanged();
    }
    
    public List<Korisnik> vratiKorisnike(){
        return korisnici;
    }
    
}
