/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package view.model;

import domen.Artikal;
import domen.Racun;
import domen.StavkaRacuna;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelStavkaRacuna extends AbstractTableModel{
    private Racun racun;
    String naziviKolona[]=new String[]{"RB","Artikal","Cena","Kolicina","Iznos"};
    
    public TableModelStavkaRacuna(Racun racun){
        this.racun=racun;
    }
    
    @Override
    public int getRowCount() {
        return racun.getStavke().size();
    }

    @Override
    public int getColumnCount() {
        return naziviKolona.length;
    }

    @Override
    public String getColumnName(int column) {
        return naziviKolona[column]; //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaRacuna stavka=racun.getStavke().get(rowIndex);
        switch(columnIndex){
            case 0: return stavka.getRbStavke();
            case 1: return stavka.getArtikal();
            case 2: return stavka.getArtikal().getCena();
            case 3: return stavka.getKolicina();
            case 4: return stavka.getIznos();
            default: return "N/A";
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaRacuna stavka=racun.getStavke().get(rowIndex);
        switch(columnIndex){
            case 0: stavka.setRbStavke(Integer.parseInt(aValue.toString())); break;
            case 1: stavka.setArtikal((Artikal)aValue); stavka.setIznos(stavka.getKolicina()*stavka.getArtikal().getCena()); fireTableDataChanged(); break;
            case 2: break;
            case 3: stavka.setKolicina(Double.parseDouble(aValue.toString())); stavka.setIznos(stavka.getKolicina()*stavka.getArtikal().getCena()); fireTableDataChanged(); break;
            case 4: stavka.setIznos(stavka.getKolicina()*stavka.getArtikal().getCena()); break;
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if(columnIndex==0 || columnIndex==2 || columnIndex==4){
            return false;
        }
        return true;
    }
    
    public void dodajStavku(StavkaRacuna stavka){
        stavka.setRacun(racun);
        stavka.setRbStavke(racun.getStavke().size()+1);
        racun.getStavke().add(stavka);
        fireTableDataChanged();
    }
    
    public void obrisiStavku(int rowIndex){
        StavkaRacuna stavkaZaBrisanje=racun.getStavke().get(rowIndex);
        racun.getStavke().remove(stavkaZaBrisanje);
        for(int i=0;i<racun.getStavke().size();i++){
            StavkaRacuna stavka=racun.getStavke().get(i);
            stavka.setRbStavke(i+1);
        }
        fireTableDataChanged();
    }
    
    public Racun vratiRacun(){
        return racun;
    }
}
